﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;
using HelloWorldService;

namespace HelloWorldClient
{
	//
	// Hello World 서비스 클라이언트 구현
	//
	class ClientApp
	{
		static void Main(string[] args)
		{
			InvokeUsingHTTP();
			InvokeUsingTCP();
		}

		// BasicHttpBinding을 사용하는 클라이언트 예제 코드
		static void InvokeUsingHTTP()
		{
			Uri uri = new Uri("http://localhost/wcf/example/helloworldservice");
			ServiceEndpoint ep = new ServiceEndpoint(
				ContractDescription.GetContract(typeof(IHelloWorld)),
				new BasicHttpBinding(),
				new EndpointAddress(uri));

			ChannelFactory<IHelloWorld> factory = new ChannelFactory<IHelloWorld>(ep);
			IHelloWorld proxy = factory.CreateChannel();
			string result = proxy.SayHello();
			(proxy as IDisposable).Dispose();
			Console.WriteLine(result);
		}

		// NetTcpBinding을 사용하는 클라이언트 예제 코드
		static void InvokeUsingTCP()
		{
			Uri uri = new Uri("net.tcp://localhost/wcf/example/helloworldservice");
			ServiceEndpoint ep = new ServiceEndpoint(
				ContractDescription.GetContract(typeof(IHelloWorld)),
				new NetTcpBinding(),
				new EndpointAddress(uri));

			ChannelFactory<IHelloWorld> factory = new ChannelFactory<IHelloWorld>(ep);
			IHelloWorld proxy = factory.CreateChannel();
			string result = proxy.SayHello();
			(proxy as IDisposable).Dispose();
			Console.WriteLine(result);
		}
	}
}
