﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using TxClientApp.TxService;
using System.ServiceModel;

namespace TxClientApp
{
	public partial class TxClientForm : Form
	{
		private string endpointConfigName;

		public TxClientForm()
		{
			InitializeComponent();

			rbBasicHttpBinding.Tag = "BasicHttpBinding_ITxService";
			rbWSHttpBinding.Tag = "WSHttpBinding_ITxService";
			rbNetNamedPipeBinding.Tag = "NetNamedPipeBinding_ITxService";
			rbNetTcpBinding.Tag = "NetTcpBinding_ITxService";
		}

		private void TxClientForm_Load(object sender, EventArgs e)
		{
			rbBasicHttpBinding.Checked = true;
		}

		private void Binding_CheckedChanged(object sender, EventArgs e)
		{
			RadioButton radioButton = (RadioButton)sender;
			if (radioButton.Checked == true) {
				endpointConfigName = (string)radioButton.Tag;
				ChannelFactory<ITxService> factory = new ChannelFactory<ITxService>(endpointConfigName);
				txtAddress.Text = factory.Endpoint.Address.Uri.ToString();
				txtBindingName.Text = factory.Endpoint.Binding.GetType().FullName;
				txtContractName.Text = factory.Endpoint.Contract.ContractType.FullName;
			}
		}

		private void btnInvokeService_Click(object sender, EventArgs e)
		{
			using (TxServiceClient proxy = new TxServiceClient(endpointConfigName)) {
				int ret = proxy.InsertData(9999);
				MessageBox.Show("Inserted Data ID = " + ret.ToString(), "Service Result",
					MessageBoxButtons.OK, MessageBoxIcon.Information);
			}
		}
	}
}
