﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.ServiceModel;
using System.Transactions;

namespace TxServiceApp1
{
	[ServiceContract]
	interface ITxService1
	{
		[OperationContract]
		[TransactionFlow(TransactionFlowOption.Mandatory)]
		int InsertData(int val, bool throwException);

		[OperationContract]
		DataSet GetData();
	}

	class TxService1 : ITxService1
	{
		private const string ConnStr = "SERVER=(local);Trusted_Connection=true;DATABASE=TestDB";

		[OperationBehavior(TransactionScopeRequired = true)]
		public int InsertData(int val, bool throwException)
		{
			Console.WriteLine("TxService1.InsertData invoked...");
			string query = "INSERT INTO TestTable VALUES(@val, 'TempData'); " +
						"SELECT @@IDENTITY";
			SqlConnection conn = new SqlConnection(ConnStr);
			SqlCommand cmd = new SqlCommand(query, conn);

			cmd.Parameters.Add("@val", SqlDbType.Int).Value = val;
			conn.Open();
			decimal id = (decimal)cmd.ExecuteScalar();
			Console.WriteLine("New data id = {0}", id);
			conn.Close();

			if (throwException == true) {
				throw new FaultException<string>("Force exception", "Transaction Error for Test");
			}

			return (int)id;
		}

		public DataSet GetData()
		{
			string query = "SELECT * FROM TestTable";
			SqlDataAdapter adapter = new SqlDataAdapter(query, ConnStr);
			DataSet ds = new DataSet();
			adapter.Fill(ds);
			return ds;
		}
	}

	class ServiceApp1
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Transaction Completion Test Service #1......");

			ServiceHost host = new ServiceHost(typeof(TxService1));
			host.Open();
			Console.WriteLine("The service started... Press any key to stop...");
			Console.ReadKey(true);
			host.Close();
		}
	}
}
