﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.ServiceModel;
using System.Messaging;
using System.ServiceModel.Description;

namespace GenerateInvalidMessage
{
	public partial class DLQTestForm : Form
	{
		public DLQTestForm()
		{
			InitializeComponent();
		}

		private void DLQTestForm_Load(object sender, EventArgs e)
		{
			foreach (object val in Enum.GetValues(typeof(DeadLetterQueue))) {
				cbxDLQ.Items.Add(val);
			}
			cbxDLQ.SelectedItem = DeadLetterQueue.System;
		}

		private void txtCustomDLQName_TextChanged(object sender, EventArgs e)
		{
			txtCustomDLQAddress.Text = String.Format("net.msmq://localhost/private$/{0}", txtCustomDLQName.Text);
		}

		private void btnCreateQueue_Click(object sender, EventArgs e)
		{
			string queuePath = String.Format(".\\private$\\{0}", txtCustomDLQName.Text);
			if (MessageQueue.Exists(queuePath) == false) {
				MessageQueue.Create(queuePath, true);
			}
		}

		private void btnCallService_Click(object sender, EventArgs e)
		{
			string address = cbxAddress.Text;
			TimeSpan timeToLive = TimeSpan.Parse(txtTimeToLive.Text);
			DeadLetterQueue dlq = (DeadLetterQueue)cbxDLQ.SelectedItem;
			Uri customDLQAddress = new Uri(txtCustomDLQAddress.Text);
			// 바인딩 설정
			NetMsmqBinding binding = new NetMsmqBinding();
			binding.DeadLetterQueue = dlq;
			if (dlq == DeadLetterQueue.Custom) {
				binding.CustomDeadLetterQueue = customDLQAddress;
			}
			binding.TimeToLive = timeToLive;
			binding.Security.Mode = NetMsmqSecurityMode.None;
			// 서비스 종점 설정
			ServiceEndpoint ep = new ServiceEndpoint(
				ContractDescription.GetContract(typeof(IMsmqService)),
				binding,
				new EndpointAddress(address));
			// 채널 팩토리 설정
			ChannelFactory<IMsmqService> factory = new ChannelFactory<IMsmqService>(ep);
			// 프록시 생성 및 서버스 호출
			IMsmqService proxy = factory.CreateChannel();
			using (proxy as IDisposable) {
				proxy.TestMethod(txtMessage.Text);
			}
		}
	}
}
