﻿using System;
using System.Collections.Generic;
using System.Text;
using BindingTestClientApp.TestService;
using System.ServiceModel.Description;
using BindingExtension;
using System.ServiceModel;

namespace BindingTestClientApp
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("CustomHttpBinding Test Client......");

			ServiceEndpoint ep = new ServiceEndpoint(
				ContractDescription.GetContract(typeof(ITestService)),
				new CustomHttpBinding(),
				new EndpointAddress("http://localhost/wcf/example/custombinding/custom"));
			ChannelFactory<ITestService> factory = new ChannelFactory<ITestService>(ep);
			factory.Credentials.UserName.UserName = "TempUser";
			factory.Credentials.UserName.Password = "1234";
			ITestService proxy = factory.CreateChannel();
			using (proxy as IDisposable) {
				proxy.TestMethod();
			}

			//using (TestServiceClient proxy = new TestServiceClient()) {
			//    proxy.ClientCredentials.UserName.UserName = "TempUser";
			//    proxy.ClientCredentials.UserName.Password = "1234";
			//    proxy.TestMethod();
			//}
		}
	}
}
