﻿using System;
using System.Runtime.Serialization;

namespace UserInfoExtension
{
	// 사용자 정보 클래스
	[DataContract(Namespace="http://noname.com/userinfo")]
	public class UserInfo
	{
		[DataMember]
		public string UserId;
		[DataMember]
		public string Name;
		[DataMember]
		public string DeptId;

		[ThreadStatic]
		private static UserInfo _currentUserInfo = null;

		public static UserInfo Current
		{
			get { return _currentUserInfo; }
			set
			{
				lock (typeof(UserInfo)) {
					_currentUserInfo = value;
				}
			}
		}
	}
}
