﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;
using HelloWorldService;

namespace HelloWorldClient
{
	//
	// Hello World 서비스 클라이언트 구현
	//
	class ClientApp
	{
		static void Main(string[] args)
		{
			//
			// 서비스 구현에 맞추어 적절한 메쏘드의 커멘트를 제거하고 테스트 한다.
			//
			InvokeUsingHTTPWithConfig();
			//InvokeUsingHTTPWithConfig2();
			InvokeUsingTCPWithConfig();
		}

		// configuration을 이용하여 서비스 호출 (BasicHttpBinding)
		static void InvokeUsingHTTPWithConfig()
		{
			ChannelFactory<IHelloWorld> factory = 
				new ChannelFactory<IHelloWorld>("HttpHelloWorld");
			IHelloWorld proxy = factory.CreateChannel();
			string result = proxy.SayHello();
			(proxy as IDisposable).Dispose();
			Console.WriteLine(result);
		}

		// configuration을 이용하여 서비스 호출 (BasicHttpBinding)
		static void InvokeUsingHTTPWithConfig2()
		{
			// 여기에서 configuration을 읽어 ChannelFactory 객체를 초기화한다.
			ChannelFactory<IHelloWorld> factory =
				new ChannelFactory<IHelloWorld>("HttpHelloWorld");
			// 다음과 같은 코드를 통해 configuration에 설정된 사항을
			// 오버라이드 할 수 있다.
			BasicHttpBinding binding = factory.Endpoint.Binding as BasicHttpBinding;
			if (binding != null) {
				binding.MessageEncoding = WSMessageEncoding.Text;
			}

			IHelloWorld proxy = factory.CreateChannel();
			string result = proxy.SayHello();
			(proxy as IDisposable).Dispose();
			Console.WriteLine(result);
		}

		// configuration을 이용하여 서비스 호출 (NetTcpBinding)
		static void InvokeUsingTCPWithConfig()
		{
			ChannelFactory<IHelloWorld> factory = 
				new ChannelFactory<IHelloWorld>("TcpHelloWorld");
			IHelloWorld proxy = factory.CreateChannel();
			string result = proxy.SayHello();
			(proxy as IDisposable).Dispose();
			Console.WriteLine(result);
		}
	}
}
