﻿using System;
using System.ServiceModel;
using HelloWorldClient4.localhost;

namespace HelloWorldClient4
{
	// 수작업으로 작성한 프록시 코드
	public class MyProxy : ClientBase<IHelloWorld>, IHelloWorld
	{
		public MyProxy(string configurationName)
			: base(configurationName)
		{
		}

		public string SayHello()
		{
			return base.Channel.SayHello();
		}
	}

	//
	// Hello World 서비스 클라이언트 구현
	//
	class ClientApp4
	{
		static void Main(string[] args)
		{
			// Visual Studio가 생성해준 프록시 사용
			using (HelloWorldClient proxy =
						new HelloWorldClient("NetTcpBinding_IHelloWorld")) {
				string result = proxy.SayHello();
				Console.WriteLine(result);
			}

			// 직접 작성한 프록시 사용
			using (MyProxy proxy = 
						new MyProxy("BasicHttpBinding_IHelloWorld")) {
				//proxy.Endpoint.Address =
				//    new EndpointAddress("http://localhost:51551/HelloWorld.svc");
				string result = proxy.SayHello();
				Console.WriteLine(result);
			}
		}
	}
}
