﻿using System;

using CompositeDataContractClient.BookStore;

namespace CompositeDataContractClient
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Composite Data Contract Client Example ......");

			using (BookStoreClient proxy = new BookStoreClient()) {
				BookInfo info = proxy.GetBookInfo("000-001");
				Console.WriteLine("Book Information:\n  Title={0}\n  ISBN={1}",
					info.Title, info.Isbn);
				Console.WriteLine("  Author={0}\n      Email={1}\n      Address={2}",
					info.AuthorInfo.FullName, info.AuthorInfo.Email, info.AuthorInfo.Address);

				BookInfo info2 = proxy.GetBookInfo("000-002");
				Console.WriteLine("Book Information:\n  Title={0}\n  ISBN={1}",
					info2.Title, info2.Isbn);
				Console.WriteLine("  Author={0}\n      Email={1}\n      Address={2}",
					info2.AuthorInfo.FullName, info2.AuthorInfo.Email, info2.AuthorInfo.Address);

				Console.WriteLine("EqualReference test: info.AuthorInfo == info2.AuthorInfo ? {0}",
					info.AuthorInfo == info2.AuthorInfo);
			}
		}
	}
}
