using System;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.Runtime.Serialization;
using System.Data;

[ServiceContract(Namespace = "http://noname.com/bookstore")]
public interface IBookStore
{
	[OperationContract]
	DataSet GetBookList(string category);
	
	[OperationContract]
	[XmlSerializerFormat]
	DataSet GetBookList2(string category);
}

class BookStoreService : IBookStore
{
	public DataSet GetBookList(string category)
	{
		return null;
	}

	public DataSet GetBookList2(string category)
	{
		return null;
	}
}

public class ServiceApp
{
	public static void Main()
	{
		Console.WriteLine("DataSet & XmlSerializer Sample......");
		ServiceHost host = new ServiceHost(typeof(BookStoreService),
			new Uri("http://loner/wcf/example/bookstoreservice"));
		host.AddServiceEndpoint(
			typeof(IBookStore),
			new BasicHttpBinding(),
			"http://loner/wcf/example/bookstoreservice");
		
		ServiceMetadataBehavior behavior = new ServiceMetadataBehavior();
		behavior.HttpGetEnabled = true;
		host.Description.Behaviors.Add(behavior);

		host.Open();
		Console.WriteLine("Press Any Key to Stop Service...");
		Console.ReadKey(true);
		host.Close();
	}
}