﻿using System;
using System.ServiceModel;

namespace TestServiceApp2
{
	// 서비스 계약 선언
	[ServiceContract]
	interface ITestContract2
	{
		[OperationContract]
		void Method2();
	}

	// 서비스 구현
	class TestService2 : ITestContract2
	{
		public void Method2()
		{
			Console.WriteLine("Method2() invoked...");
		}
	}

	class ServiceApp2
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Named Pipe URI Test Service #2......");

			// 다음 코드는 TestService1 와 동일한 명명된 파이프 이름을 사용하게 된다.
			// 따라서 두 서비스가 동시에 수행될 수 없다.
			//ServiceHost host = new ServiceHost(typeof(TestService2),
			//    new Uri("net.pipe://localhost/samples"));
			//host.AddServiceEndpoint(typeof(ITestContract2), new NetNamedPipeBinding(), "service2");
			ServiceHost host = new ServiceHost(typeof(TestService2));
			host.AddServiceEndpoint(typeof(ITestContract2), 
				new NetNamedPipeBinding(), "net.pipe://localhost/samples/service2");
			host.Open();
			Console.WriteLine("Press Any Key to Stop");
			Console.ReadKey(true);
			host.Close();
		}
	}
}
