﻿using System;
using System.ServiceModel;

namespace TestSeviceApp1
{
	// 서비스 계약 선언
	[ServiceContract]
	interface ITestContract1
	{
		[OperationContract]
		void Method1();
	}

	// 서비스 구현
	class TestService1 : ITestContract1
	{
		public void Method1()
		{
			Console.WriteLine("Method1() invoked...");
		}
	}

	class ServiceApp1
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Named Pipe URI Test Service #1......");

			// 다음 코드는 TestService2 와 동일한 명명된 파이프 이름을 사용하게 된다.
			// 따라서 두 서비스가 동시에 수행될 수 없다.
			//ServiceHost host = new ServiceHost(typeof(TestService1),
			//    new Uri("net.pipe://localhost/samples"));
			//host.AddServiceEndpoint(typeof(ITestContract1), new NetNamedPipeBinding(), "testservice1");
			ServiceHost host = new ServiceHost(typeof(TestService1));
			host.AddServiceEndpoint(typeof(ITestContract1), 
				new NetNamedPipeBinding(), "net.pipe://localhost/samples/service1");
			host.Open();
			Console.WriteLine("Press Any Key to Stop");
			Console.ReadKey(true);
			host.Close();
		}
	}
}
