﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Description;

namespace WindowsServiceHost
{
	public partial class WCFHostService : ServiceBase
	{
		private ServiceHost _Host;

		public WCFHostService()
		{
			InitializeComponent();
		}

		#region "테스트 환경에서 서비스 구동시 사용하는 메쏘드"

		public void ServiceStart()
		{
			this.OnStart(new string[] { });
		}

		public void ServiceStop()
		{
			this.OnStop();
		}
		#endregion

		// Windows 서비스 구동 시 호출되는 메쏘드
		protected override void OnStart(string[] args)
		{
			// 서비스 호스트 초기화
			_Host = new ServiceHost(typeof(BookStoreService),
				new Uri("http://localhost/wcf/example/bookstoreservice"));
			_Host.AddServiceEndpoint(typeof(IBookStore),
				new WSHttpBinding(), "");
			// WSDL 활성화
			ServiceMetadataBehavior behavior = new ServiceMetadataBehavior();
			_Host.Description.Behaviors.Add(behavior);
			behavior.HttpGetEnabled = true;
			// 서비스 구동
			_Host.Open();
		}

		//  Windows 서비스 중단 시 호출되는 메쏘드
		protected override void OnStop()
		{
			_Host.Close();
		}
	}
}
