﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ServerTimeClientApp.ServerTimeService;
using System.ServiceModel;

namespace ServerTimeClientApp
{
	[CallbackBehavior(UseSynchronizationContext = false)]
	public partial class ServerTimeForm : Form, IServerTimeCallback
	{
		private ServerTimeClient _serverTimeProxy;
		public ServerTimeForm()
		{
			InitializeComponent();
		}

		private void ServerTimeForm_Load(object sender, EventArgs e)
		{
			InstanceContext ctx = new InstanceContext(this);
			_serverTimeProxy = new ServerTimeClient(ctx);
			_serverTimeProxy.Open();						// establish session
			_serverTimeProxy.Subscribe();
		}

		public void OnTick(DateTime serverTime)
		{
			MethodInvoker func = delegate {
				lblServerTime.Text = serverTime.ToString();
			};
			if (this.InvokeRequired == true) {
				this.Invoke(func);
			}
			else {
				func();
			}
		}

		private void ServerTimeForm_FormClosed(object sender, FormClosedEventArgs e)
		{
			_serverTimeProxy.Unsubscribe();
			_serverTimeProxy.Close();
		}

		private void btnClose_Click(object sender, EventArgs e)
		{
			this.Close();
		}
	}

	class ServerTimeEventHandler : IServerTimeCallback, IDisposable
	{
		public ServerTimeEventHandler()
		{
			System.Diagnostics.Debug.WriteLine("Callback instance created.....");
		}

		public void Dispose()
		{
			System.Diagnostics.Debug.WriteLine("Callback instance disposing.....");
		}

		public void OnTick(DateTime serverTime)
		{
			ServerTimeForm frm = Application.OpenForms[0] as ServerTimeForm;
			frm.OnTick(serverTime);
		}
	}
}
