﻿using System;
using System.Collections.Generic;
using System.Text;
using SimpleTimeClientApp.TimeService;
using System.ServiceModel;

namespace SimpleTimeClientApp
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Time Client Sample.......");

			InstanceContext ctx = new InstanceContext(new TickHandler());
			using (TimeClient proxy = new TimeClient(ctx)) {
				proxy.Open();
				Console.WriteLine("Starting time-tick callback......");
				proxy.StartTimeService();
				System.Threading.Thread.Sleep(5000);
				proxy.Close();
			}
		}
	}

	class TickHandler : ITimeCallback
	{
		public void OnTick(DateTime time)
		{
			Console.WriteLine("  OnTick : {0}", time);
		}
	}
}
